// Code generated by Wire. DO NOT EDIT.

//go:generate go run github.com/google/wire/cmd/wire
//go:build !wireinject
// +build !wireinject

package container

import (
	"gitlab.com/muhammadandikakurniawan1/exercise/awan_service/web_message_broker_service/src/config"
	"gitlab.com/muhammadandikakurniawan1/exercise/awan_service/web_message_broker_service/src/helper/broker_client"
	"gitlab.com/muhammadandikakurniawan1/exercise/awan_service/web_message_broker_service/src/usecase/consumer"
)

// Injectors from container.go:

func InitializeContainer() *Container {
	appConfig := config.LoadConfigFromEnv()
	brokerClientManager := brokerclient.NewBrokerClientManager()
	consumerUsecase := consumer.NewConsumerUsecase(brokerClientManager)
	container := SetupContainer(appConfig, brokerClientManager, consumerUsecase)
	return container
}

// container.go:

type Container struct {
	AppConfig           config.AppConfig
	BrokerClientManager brokerclient.BrokerClientManager
	ConsumerUsecase     consumer.ConsumerUsecase
}

func SetupContainer(
	AppConfig config.AppConfig,
	BrokerClientManager brokerclient.BrokerClientManager,
	ConsumerUsecase consumer.ConsumerUsecase,
) *Container {
	return &Container{
		AppConfig:           AppConfig,
		BrokerClientManager: BrokerClientManager,
		ConsumerUsecase:     ConsumerUsecase,
	}
}
